Index: /extensions/NBC_UserAdvManager/branches/2.15/language/it_IT/help/plugin.lang.php
===================================================================
--- /extensions/NBC_UserAdvManager/branches/2.15/language/it_IT/help/plugin.lang.php	(revision 6775)
+++ /extensions/NBC_UserAdvManager/branches/2.15/language/it_IT/help/plugin.lang.php	(revision 6776)
@@ -3,11 +3,4 @@
 
 $lang['UAM_restricTitle'] = 'Restrizioni per le iscrizzioni';
-$lang['UAM_restricTitle_d'] = '
-- Sensibilità maiuscole/minuscole<br>
-- Caratteri vietati nei nomi degli utenti<br>
-- Rafforzare il livello di sicurezza delle password<br>
-- Esclusione dei domini d\'Email<br>
-...
-';
 $lang['UAM_confirmTitle'] = 'Confirmazzione e validazione delle iscrizzioni';
 $lang['UAM_confirmTitle_d'] = '
@@ -53,8 +46,4 @@
 Per utilizzare più lingue, è possibile utilizzare i tag del plugin Extended Description, se esso è attivo.<br><br>
 <b style=&quot;color: red;&quot;>Modifica del testo &egrave; disponibile solo se &quot;E-mail informazioni per l\'utente&quot; &egrave; attivata.</b>';
-$lang['UAM_confirmmailTitle'] = 'Conferma della registrazione';
-$lang['UAM_confirmmailTitle_d'] = 'Questa opzione permette di richiedere all\'utente di convalidare la registrazione cliccando su un link ricevuto in una email inviata al momento della registrazione.<br><br>
-L\'e-mail &egrave; composto da una parte personalizzabile di introdurre una piccola nota di benvenuto e una parte fissa contenente il link di attivazione che viene generato da una chiave casuale che pu&ograve; eventualmente rigenerare attraverso la &quot;Tracciamento convalide&quot; tab.<br><br>
-Questa opzione &egrave; generalmente utilizzato con l\'assegnazione automatica di gruppo e / o statuto. Ad esempio, un utente che non ha convalidato la loro registrazione sar&agrave; ambientato in un gruppo specifico di utenti (con o senza le restrizioni alla galleria), mentre un utente che ha convalidato la sua registrazione &egrave; fissato in un &quot;normale&quot; del gruppo.';
 /* TODO */$lang['UAM_confirmtxtTitle'] = 'Customizing the confirmation email';
 /* TODO */$lang['UAM_confirmtxtTitle_d'] = 'Enter the introductory text that you want to appear in the email confirmation of registration.<br><br>
@@ -99,23 +88,5 @@
 /* TODO */$lang['UAM_userlistTitle'] = 'Tracking users';
 /* TODO */$lang['UAM_usermanTitle'] = 'Tracking validations';
-/* TODO */$lang['UAM_usermanTitle_d'] = 'When limiting the deadline for registration is enabled, you will find below the list of users whose validation registration is expected, <b style=&quot;text-decoration: underline;&quot;>whether or not</b> they are in time to validate.<br><br>
-The registration date is displayed in green when the user concerned is below the time limit to validate his registration. In this case, the validation key is still valid and we can send an email with or without a new validation key.<br><br>
-When the registration date appears in red, the validation period has expired. In this case, you must send an email with regeneration of validation key if you want to enable the user to validate their registration.<br><br>
-In all cases, it is possible to manually force the validation.<br><br>
-In this view, you can:
-<br><br>
-- Manually delete accounts <b>(manual drain)</b>
-<br>
-- Generate email reminder <b>without</b> generating a new key. Warning: Send an email reminder to targeted visitors. This function does not reset the date of registration of targeted visitors and the timeout is still valid.
-<br>
-- Generate email reminder <b>with</b> generating a new key. Warning : Send an email reminder to targeted visitors. This function also resets the date of registration of targeted visitors which equates to extend the deadline for validation.
-<br>
-- Submit a registration awaiting validation manually even if the expiry date has passed <b>(forcing validation)</b>.';
 /* TODO */$lang['UAM_gtTitle'] = 'Ghost visitors management';
-/* TODO */$lang['UAM_gtTitle_d'] = 'When Ghost Tracker is enabled and initialized, you will find below the list of registered visitors who have not returned since x days. &quot;x&quot; is the number of days configured in the General Setup tab. In addition, you will find a column indicating whether an email reminder has been sent to targeted visitors. So, you can see at a glance and treat visitors who have not taken account of the reminder.<br><br>In this view, you can:
-<br><br>
-- Manually delete accounts <b>(manual drain)</b>
-<br>
-- Generate email reminder <b>with resetting the last visit date</b>. This allows to give a wildcard to targeted visitors. If the visitor has already received a reminder, nothing prevents to resent a new mail which will reset again, in fact, the last visit date.';
 
 
@@ -126,24 +97,4 @@
 Disabilitando questa opzione ((predefinito)), solo le informazioni e-mail viene inviata (se &quot;E-mail informazioni per l\'utente&quot; &egrave; abilitato).';
 // --------- End: New or revised $lang ---- from version 2.14.0
-
-
-
-// --------- Starting below: New or revised $lang ---- from version 2.14.1
-/* TODO */$lang['UAM_userlistTitle_d'] = 'This page is for information to the administrator. It displays a list of all users registered on the gallery showing the date and number of days since their last visit. The list is sorted in ascending order of number of days.
-<br><br>
-<b><u>Only when the Ghost Tracker is active</u></b>, the number of days without a visit appears as the following color code, according to the maximum set in the Ghost Tracker options:
-<br>
-- <b style=&quot;color: lime;&quot;>Green</b> : When the user has visited the gallery <b style=&quot;color: lime;&quot;><u>less than 50%</u></b> of the maximum indicated in the Ghost Tracker.<br>
-- <b style=&quot;color: orange;&quot;>Orange</b> : When the user has visited the gallery <b style=&quot;color: orange;&quot;><u> between 50% and 99% </u></b> of the maximum indicated in the Ghost Tracker.<br>
-- <b style=&quot;color: red;&quot;>Red</b> : When the user has visited the gallery <b style=&quot;color: red;&quot;><u>for more than 100%</u></b> of the maximum indicated in the Ghost Tracker. <b><u>In this case, the user must also appear in the Ghost Tracker table.</u></b><br>
-<br>
-Example :
-<br>
-The maximum period of Ghost Tracker is configured to 100 days.
-<br>
-A user will appear in green if he visited the gallery for less than 50 days, in orange if his last visit took place between 50 and 99 days and red for 100 days and above.
-<br><br>
-<b>NOTE</b> : The list does not display who have not validated their registration (if the option of validating the registration is activated). These users are then managed in a special way in the &quot;Tracking validations&quot; tab.';
-// --------- End: New or revised $lang ---- from version 2.14.1
 
 
@@ -167,3 +118,61 @@
 <b style=&quot;color: red&quot;>Attenzione: questa opzione non ha alcun effetto sui pseudo creati prima della sua attivazione.</b>';
 // --------- End: New or revised $lang ---- from version 2.15.2
+
+
+// --------- Starting below: New or revised $lang ---- from version 2.15.4
+$lang['UAM_restricTitle_d'] = '
+- Caratteri vietati nei nomi degli utenti<br>
+- Rafforzare il livello di sicurezza delle password<br>
+- Esclusione dei domini d\'Email<br>
+...
+';
+/* TODO */$lang['UAM_userlistTitle_d'] = 'This page is for information to the administrator. It displays a list of all users registered on the gallery showing the date and number of days since their last visit. The list is sorted in ascending order of number of days.
+<br><br>
+<b><u>Only when the Ghost Tracker is active</u></b>, the number of days without a visit appears as the following color code, according to the maximum set in the Ghost Tracker options:
+<br>
+- <b style=&quot;color: lime;&quot;>Green</b> : When the user has visited the gallery <b style=&quot;color: lime;&quot;><u>less than 50%</u></b> of the maximum indicated in the Ghost Tracker.<br>
+- <b style=&quot;color: orange;&quot;>Orange</b> : When the user has visited the gallery <b style=&quot;color: orange;&quot;><u> between 50% and 99% </u></b> of the maximum indicated in the Ghost Tracker.<br>
+- <b style=&quot;color: red;&quot;>Red</b> : When the user has visited the gallery <b style=&quot;color: red;&quot;><u>for more than 100%</u></b> of the maximum indicated in the Ghost Tracker. <b><u>In this case, the user must also appear in the Ghost Tracker table.</u></b><br>
+<br>
+Example :
+<br>
+The maximum period of Ghost Tracker is configured to 100 days.
+<br>
+A user will appear in green if he visited the gallery for less than 50 days, in orange if his last visit took place between 50 and 99 days and red for 100 days and above.
+<br><br>
+<b>NOTE</b>: The list does not display who have not validated their registration (if the option of validating the registration is activated). These users are then managed in a special way in the &quot;Tracking validations&quot; tab.
+<br><br>
+<b>Table Sorting Function</b>: You can sort the data displayed by clicking on the column headers. Hold the SHIFT key to sort up to 4 simultaneous columns.';
+/* TODO */$lang['UAM_usermanTitle_d'] = 'When limiting the deadline for registration is enabled, you will find below the list of users whose validation registration is expected, <b style=&quot;text-decoration: underline;&quot;>whether or not</b> they are in time to validate.<br><br>
+The registration date is displayed in green when the user concerned is below the time limit to validate his registration. In this case, the validation key is still valid and we can send an email with or without a new validation key.<br><br>
+When the registration date appears in red, the validation period has expired. In this case, you must send an email with regeneration of validation key if you want to enable the user to validate their registration.<br><br>
+In all cases, it is possible to manually force the validation.<br><br>
+In this view, you can:
+<br><br>
+- Manually delete accounts <b>(manual drain)</b>
+<br>
+- Generate email reminder <b>without</b> generating a new key. Warning: Send an email reminder to targeted visitors. This function does not reset the date of registration of targeted visitors and the timeout is still valid.
+<br>
+- Generate email reminder <b>with</b> generating a new key. Warning : Send an email reminder to targeted visitors. This function also resets the date of registration of targeted visitors which equates to extend the deadline for validation.
+<br>
+- Submit a registration awaiting validation manually even if the expiry date has passed <b>(forcing validation)</b>.
+<br><br>
+<b>Table Sorting Function</b>: You can sort the data displayed by clicking on the column headers. Hold the SHIFT key to sort up to 4 simultaneous columns.';
+/* TODO */$lang['UAM_gtTitle_d'] = 'When Ghost Tracker is enabled and initialized, you will find below the list of registered visitors who have not returned since x days. &quot;x&quot; is the number of days configured in the General Setup tab. In addition, you will find a column indicating whether an email reminder has been sent to targeted visitors. So, you can see at a glance and treat visitors who have not taken account of the reminder.<br><br>In this view, you can:
+<br><br>
+- Manually delete accounts <b>(manual drain)</b>
+<br>
+- Generate email reminder <b>with resetting the last visit date</b>. This allows to give a wildcard to targeted visitors. If the visitor has already received a reminder, nothing prevents to resent a new mail which will reset again, in fact, the last visit date.
+<br><br>
+<b>Table Sorting Function</b>: You can sort the data displayed by clicking on the column headers. Hold the SHIFT key to sort up to 4 simultaneous columns.';
+$lang['UAM_confirmmailTitle'] = 'Conferma della registrazione';
+/*TODO*/$lang['UAM_confirmmailTitle_d'] = 'This option allows a user to either confirm registration by clicking on a link received in an email sent upon registration or the administrator to manually activate the registration.<br><br>
+In first case, the e-mail is composed of a customizable part to introduce a little welcome note and a fixed part containing the activation link that is generated from a random key that can possibly regenerate through the &quot;Tracking validations&quot; tab.<br><br>
+Dans le premier cas, le message envoyé comprend une partie fixe, avec le lien d\'activation généré à partir d\'une clef aléatoire (cette clé peut éventuellement être régénérée via l\'onglet &quot;Suivi des validations&quot;), et une partie personnalisable par un texte d\'accueil.
+<br><br>
+Questa opzione &egrave; generalmente utilizzato con l\'assegnazione automatica di gruppo e / o statuto. Ad esempio, un utente che non ha convalidato la loro registrazione sar&agrave; ambientato in un gruppo specifico di utenti (con o senza le restrizioni alla galleria), mentre un utente che ha convalidato la sua registrazione &egrave; fissato in un &quot;normale&quot; del gruppo.';
+/*TODO*/$lang['UAM_RedirTitle'] = 'Redirect to &quot;Customization&quot; page';
+/*TODO*/$lang['UAM_RedirTitle_d'] = 'This option automatically redirect a registered user to his customization page only at his first connection to the gallery.<br><br>
+Please note: This feature applies to all already registered users including those with &quot;admin&quot;, &quot;webmaster&quot; or &quot;generic&quot; status.';
+// --------- End: New or revised $lang ---- from version 2.15.4
 ?>
Index: /extensions/NBC_UserAdvManager/branches/2.15/language/it_IT/plugin.lang.php
===================================================================
--- /extensions/NBC_UserAdvManager/branches/2.15/language/it_IT/plugin.lang.php	(revision 6775)
+++ /extensions/NBC_UserAdvManager/branches/2.15/language/it_IT/plugin.lang.php	(revision 6776)
@@ -30,6 +30,5 @@
 $lang['Err_audit_advise'] = '<b>Dovete eseguire delle correzioni per rispettare le nuove impostazzioni che avete attivato.<br> Utilizzare un programma per la gestione della base dati per correggere i conti utente direttamente nella tabella ###_USERS';
 $lang['UAM_Empty Author'] = 'Il campo autore deve essere riempito per potere inviare un commento.';
-if ( isset($conf_UAM[1]) and $conf_UAM[1] == 'true' )
-	$lang['reg_err_login5'] = 'Nome utente esiste già. Attenzione : il campo è insensibile alle maiuscole/minuscole.';
+$lang['reg_err_login5'] = 'Nome utente esiste già. Attenzione : il campo è insensibile alle maiuscole/minuscole.';
 $lang['reg_err_login6'] = 'Nome utente non deve contenere in caratteri seguenti: ';
 $lang['reg_err_login7'] = 'Il tuo provider di posta usa dominio d\'Email proibito. I domini preibiti sono i seguenti: ';
@@ -57,5 +56,4 @@
 $lang['Mail_without_key'] = 'Email di rilancio senza chiave';
 $lang['Mail_with_key'] = 'Email di rilancio con chiave';
-$lang['Force_Validation'] = 'Convalida forzata';
 
 
@@ -142,5 +140,4 @@
 $lang['UAM_MailInfo_Text'] = ' Personalizzare il testo dell\'Email:';
 $lang['UAM_Confirm_Mail'] = 'Conferma dell\'iscrizione:';
-$lang['UAM_Confirm_Mail_true'] = ' Attivare';
 $lang['UAM_Confirm_Mail_false'] = ' Disattivare (di default)';
 $lang['UAM_ConfirmMail_Text'] = ' Personalizzare il testo dell\'Email di conferma:';
@@ -264,3 +261,13 @@
 Disponibile anche, il bugtracker del progetto: <a href="http://piwigo.org/bugs/" onclick="window.open(this.href);return false;">http://piwigo.org/bugs/</a>';
 // --------- End: New or revised $lang ---- from version 2.15.1
+
+
+// --------- Starting below: New or revised $lang ---- from version 2.15.4
+/*TODO*/$lang['Force_Validation'] = 'Manual validation';
+/*TODO*/$lang['UAM_Confirm_Mail_true'] = ' Enable - Validation by user';
+/*TODO*/$lang['UAM_Confirm_Mail_local'] = ' Enable - Validation by admin (no validation key sent)';
+/*TODO*/$lang['UAM_RedirToProfile'] = 'Redirect to "Customization" page';
+$lang['UAM_RedirToProfile_false'] = ' Disattivare (di default)';
+$lang['UAM_RedirToProfile_true'] = ' Attivare';
+// --------- End: New or revised $lang ---- from version 2.15.4
 ?>
Index: /extensions/NBC_UserAdvManager/branches/2.15/main.inc.php
===================================================================
--- /extensions/NBC_UserAdvManager/branches/2.15/main.inc.php	(revision 6775)
+++ /extensions/NBC_UserAdvManager/branches/2.15/main.inc.php	(revision 6776)
@@ -2,5 +2,5 @@
 /*
 Plugin Name: UserAdvManager
-Version: 2.15.3
+Version: 2.15.4
 Description: Renforcer la gestion des utilisateurs - Enforce users management
 Plugin URI: http://fr.piwigo.org/ext/extension_view.php?eid=216
@@ -13,6 +13,4 @@
 /*
  ***** TODO List *****
-++ Adding ASC and DESC ordering for user's lists tables (Ghost Tracker, UserList and Unvalidated) ?
-
 ++ No validation needed for admins users comments (new trigger needed in comments.php ?)
 
@@ -80,5 +78,5 @@
   if (!is_admin() and !is_a_guest())
   {
-    if ((isset($conf_UAM[17]) and $conf_UAM[17] == 'true') or (isset($conf_UAM[20]) and $conf_UAM[20] == 'true'))
+    if ((isset($conf_UAM[16]) and $conf_UAM[16] == 'true') or (isset($conf_UAM[19]) and $conf_UAM[19] == 'true'))
     {
 
@@ -128,21 +126,39 @@
   $conf_UAM = unserialize($conf['UserAdvManager']);
   
-  /* Sending registration confirmation by email */
-  if ((isset($conf_UAM[0]) and $conf_UAM[0] == 'true') or (isset($conf_UAM[2]) and $conf_UAM[2] == 'true'))
-  {
-    if (is_admin() and isset($conf_UAM[21]) and $conf_UAM[21] == 'true')
-    {
-    $passwd = (isset($_POST['password'])) ? $_POST['password'] : '';
-    SendMail2User(1, $register_user['id'], $register_user['username'], $passwd, $register_user['email'], true); 
-    }
-    elseif (is_admin() and isset($conf_UAM[21]) and $conf_UAM[21] == 'false')
-    {
+  if ((isset($conf_UAM[0]) and $conf_UAM[0] == 'true') and (isset($conf_UAM[1]) and $conf_UAM[1] == 'local'))
+  {
+    /* This is to send an information email and set user to "waiting" group or status until admin validation */
     $passwd = (isset($_POST['password'])) ? $_POST['password'] : '';
     SendMail2User(1, $register_user['id'], $register_user['username'], $passwd, $register_user['email'], false);
+    setgroup($register_user['id']);// Set to "waiting" group or status until admin validation
+  }
+  elseif ((isset($conf_UAM[0]) and $conf_UAM[0] == 'false') and (isset($conf_UAM[1]) and $conf_UAM[1] == 'local'))
+  {
+    /* This is to set user to "wainting" group or status until admin validation */
+    setgroup($register_user['id']);// Set to "waiting" group or status until admin validation
+  }
+  elseif ((isset($conf_UAM[0]) and $conf_UAM[0] == 'true') and (isset($conf_UAM[1]) and $conf_UAM[1] == 'false'))
+  {
+    /* This is to send an information email without validation key */
+    $passwd = (isset($_POST['password'])) ? $_POST['password'] : '';
+    SendMail2User(1, $register_user['id'], $register_user['username'], $passwd, $register_user['email'], false);
+  }
+  /* Sending registration confirmation by email */
+  elseif ((isset($conf_UAM[0]) and $conf_UAM[0] == 'true') and (isset($conf_UAM[1]) and $conf_UAM[1] == 'true'))
+  {
+    if (is_admin() and isset($conf_UAM[20]) and $conf_UAM[20] == 'true')
+    {
+      $passwd = (isset($_POST['password'])) ? $_POST['password'] : '';
+      SendMail2User(1, $register_user['id'], $register_user['username'], $passwd, $register_user['email'], true); 
+    }
+    elseif (is_admin() and isset($conf_UAM[20]) and $conf_UAM[20] == 'false')
+    {
+      $passwd = (isset($_POST['password'])) ? $_POST['password'] : '';
+      SendMail2User(1, $register_user['id'], $register_user['username'], $passwd, $register_user['email'], false);
     }
     elseif (!is_admin())
     {
-    $passwd = (isset($_POST['password'])) ? $_POST['password'] : '';
-    SendMail2User(1, $register_user['id'], $register_user['username'], $passwd, $register_user['email'], true);
+      $passwd = (isset($_POST['password'])) ? $_POST['password'] : '';
+      SendMail2User(1, $register_user['id'], $register_user['username'], $passwd, $register_user['email'], true);
     }
   }
@@ -159,4 +175,6 @@
   /* Cleanup for LastVisit table */
   DeleteLastVisit($user_id);
+  /* Cleanup Redirection settings */
+  DeleteRedir($user_id);
 }
 
@@ -253,5 +271,5 @@
 
   /* Password enforcement control */
-  if (isset($conf_UAM[14]) and $conf_UAM[14] == 'true' and !empty($conf_UAM[15]))
+  if (isset($conf_UAM[13]) and $conf_UAM[13] == 'true' and !empty($conf_UAM[14]))
   {
     if (!empty($user['password']) and !is_admin())
@@ -259,40 +277,34 @@
       $PasswordCheck = testpassword($user['password']);
   
-      if ($PasswordCheck < $conf_UAM[15])
+      if ($PasswordCheck < $conf_UAM[14])
       {
         $message = get_l10n_args('reg_err_login4_%s', $PasswordCheck);
-        return($lang['reg_err_pass'] = l10n_args($message).$conf_UAM[15]);
-      }
-    }
-    else if (!empty($user['password']) and is_admin() and isset($conf_UAM[16]) and $conf_UAM[16] == 'true')
+        return($lang['reg_err_pass'] = l10n_args($message).$conf_UAM[14]);
+      }
+    }
+    else if (!empty($user['password']) and is_admin() and isset($conf_UAM[15]) and $conf_UAM[15] == 'true')
     { 
       $PasswordCheck = testpassword($user['password']);
   
-      if ($PasswordCheck < $conf_UAM[15])
+      if ($PasswordCheck < $conf_UAM[14])
       {
         $message = get_l10n_args('reg_err_login4_%s', $PasswordCheck);
-        return($lang['reg_err_pass'] = l10n_args($message).$conf_UAM[15]);
-      }
-    }
-  }
-
-  /* Username non case sensitive */
-  if (isset($conf_UAM[1]) and $conf_UAM[1] == 'true' and NotSensibleSearchUsername($_POST['login']))
-  {
-    return($lang['reg_err_login5'] = l10n('reg_err_login5'));
+        return($lang['reg_err_pass'] = l10n_args($message).$conf_UAM[14]);
+      }
+    }
   }
 
   /* Username without forbidden keys */
-  if (isset($conf_UAM[7]) and $conf_UAM[7] == 'true' and !empty($_POST['login']) and ValidateUsername($_POST['login']) and !is_admin())
+  if (isset($conf_UAM[6]) and $conf_UAM[6] == 'true' and !empty($_POST['login']) and ValidateUsername($_POST['login']) and !is_admin())
   {
     $_POST['login'] = '';
-    return($lang['reg_err_login1'] = l10n('reg_err_login6')."'".$conf_UAM[8]."'");
+    return($lang['reg_err_login1'] = l10n('reg_err_login6')."'".$conf_UAM[7]."'");
   }
 
   /* Email without forbidden domains */
-  if (isset($conf_UAM[12]) and $conf_UAM[12] == 'true' and !empty($_POST['mail_address']) and ValidateEmailProvider($_POST['mail_address']) and !is_admin())
+  if (isset($conf_UAM[11]) and $conf_UAM[11] == 'true' and !empty($_POST['mail_address']) and ValidateEmailProvider($_POST['mail_address']) and !is_admin())
   {
     $_POST['mail_address'] = '';
-    return($lang['reg_err_login1'] = l10n('reg_err_login7')."'".$conf_UAM[13]."'");
+    return($lang['reg_err_login1'] = l10n('reg_err_login7')."'".$conf_UAM[12]."'");
   }
 }
@@ -309,12 +321,28 @@
     $conf_UAM = unserialize($conf['UserAdvManager']);
 
+    if ((isset($conf_UAM[21]) and $conf_UAM[21] == 'true'))
+    {
+      $user_idsOK = array();
+      if (!check_consult($user['id'], $user_idsOK))
+      {
+        $user_idsOK[] = $user['id'];
+        
+        $query = "
+          UPDATE ".CONFIG_TABLE."
+          SET value = \"".implode(',', $user_idsOK)."\"
+          WHERE param = 'UserAdvManager_Redir';";
+          
+        pwg_query($query);
+      }
+    }
+
     if (isset($_POST['validate']) and !is_admin())
     {
       /* Email without forbidden domains */
-      if (isset($conf_UAM[12]) and $conf_UAM[12] == 'true' and !empty($_POST['mail_address']))
+      if (isset($conf_UAM[11]) and $conf_UAM[11] == 'true' and !empty($_POST['mail_address']))
       {
         if (ValidateEmailProvider($_POST['mail_address']))
         {
-          $template->append('errors', l10n('reg_err_login7')."'".$conf_UAM[13]."'");
+          $template->append('errors', l10n('reg_err_login7')."'".$conf_UAM[12]."'");
           unset($_POST['validate']);
         }
@@ -328,12 +356,12 @@
         
         /* Password enforcement control */
-        if (isset($conf_UAM[14]) and $conf_UAM[14] == 'true' and !empty($conf_UAM[15]))
+        if (isset($conf_UAM[13]) and $conf_UAM[13] == 'true' and !empty($conf_UAM[14]))
         {
           $PasswordCheck = testpassword($_POST['use_new_pwd']);
          
-          if ($PasswordCheck < $conf_UAM[15])
+          if ($PasswordCheck < $conf_UAM[14])
           {
             $message = get_l10n_args('reg_err_login4_%s', $PasswordCheck);
-            $template->append('errors', l10n_args($message).$conf_UAM[15]);
+            $template->append('errors', l10n_args($message).$conf_UAM[14]);
             unset($_POST['use_new_pwd']);
             unset($_POST['validate']);
@@ -343,5 +371,5 @@
       
       /* Sending registration confirmation by email */
-      if ((isset($conf_UAM[0]) and $conf_UAM[0] == 'true') or (isset($conf_UAM[2]) and $conf_UAM[2] == 'true'))
+      if ((isset($conf_UAM[0]) and $conf_UAM[0] == 'true') or (isset($conf_UAM[1]) and $conf_UAM[1] == 'true') or (isset($conf_UAM[1]) and $conf_UAM[1] == 'local'))
       {
         $confirm_mail_need = false;
@@ -356,8 +384,15 @@
           
           list($current_email) = pwg_db_fetch_row(pwg_query($query));
-      
-          if ($_POST['mail_address'] != $current_email and ( isset($conf_UAM[2]) and $conf_UAM[2] == 'true'))
+
+          /* This is to send a new validation key */
+          if ($_POST['mail_address'] != $current_email and (isset($conf_UAM[1]) and $conf_UAM[1] == 'true'))
         
             $confirm_mail_need = true;
+
+          /* This is to set the user to "waiting" group or status until admin validation */
+          if ($_POST['mail_address'] != $current_email and (isset($conf_UAM[1]) and $conf_UAM[1] == 'local'))
+        
+            setgroup($register_user['id']);// Set to "waiting" group or status until admin validation
+            $confirm_mail_need = false;
         }
         
@@ -380,4 +415,26 @@
 
 
+// RedirectToProfile - Thx to LucMorizur
+// redirects a visitor (not generic (forbidden) neither admin) to his
+// profile.php page
+//
+// no variable, no return
+add_event_handler('login_success', 'RedirectToProfile');
+
+function RedirectToProfile()
+{
+  global $conf, $user;
+  
+  $conf_UAM = unserialize($conf['UserAdvManager']);
+
+  if ((isset($conf_UAM[21]) and $conf_UAM[21] == 'true'))
+  {
+    $user_idsOK = array();
+    if (!check_consult($user['id'], $user_idsOK))
+      redirect(PHPWG_ROOT_PATH.'profile.php');
+  }
+}
+
+
 add_event_handler('init', 'UAM_InitPage');
 /* *** Important ! This is necessary to make email exclusion work in admin's users management panel *** */
@@ -395,7 +452,7 @@
     {
       /* Email without forbidden domains */
-      if (isset($conf_UAM[12]) and $conf_UAM[12] == 'true' and !empty($_POST['email']) and ValidateEmailProvider($_POST['email']))
-      {
-        $template->append('errors', l10n('reg_err_login7')."'".$conf_UAM[13]."'");
+      if (isset($conf_UAM[11]) and $conf_UAM[11] == 'true' and !empty($_POST['email']) and ValidateEmailProvider($_POST['email']))
+      {
+        $template->append('errors', l10n('reg_err_login7')."'".$conf_UAM[12]."'");
         unset($_POST['submit_add']);
       }
@@ -415,5 +472,5 @@
 
 /* User creation OR update */
-  if (isset($conf_UAM[6]) and $conf_UAM[6] == 'true' and $conf['comments_forall'] == 'true' and $comm['author'] == 'guest')
+  if (isset($conf_UAM[5]) and $conf_UAM[5] == 'true' and $conf['comments_forall'] == 'true' and $comm['author'] == 'guest')
   {
     $comment_action = 'reject';
Index: /extensions/NBC_UserAdvManager/branches/2.15/maintain.inc.php
===================================================================
--- /extensions/NBC_UserAdvManager/branches/2.15/maintain.inc.php	(revision 6775)
+++ /extensions/NBC_UserAdvManager/branches/2.15/maintain.inc.php	(revision 6776)
@@ -18,5 +18,5 @@
 	global $conf;
 	
-  $default1 = array('false','false','false',-1,-1,-1,'false','false','',-1,'','','false','','false',100,'false','false',10,'Hello.
+  $default1 = array('false','false',-1,-1,-1,'false','false','',-1,'','','false','','false',100,'false','false',10,'Hello.
 	
 This is a reminder because a very long time passed since your last visit on our gallery. If you do not want anymore to use your access account, please let us know by replying to this email. Your account will be deleted.
@@ -48,4 +48,10 @@
 INSERT INTO '.CONFIG_TABLE.' (param, value, comment)
 VALUES ("UserAdvManager_ConfirmMail","'.addslashes(serialize($default2)).'","UAM ConfirmMail parameters")
+  ;';
+  pwg_query($q);
+  
+  $q = '
+INSERT INTO '.CONFIG_TABLE.' (param, value, comment)
+VALUES ("UserAdvManager_Redir","0","UAM Redirections")
   ;';
   pwg_query($q);
@@ -160,19 +166,18 @@
   }
 
-/* Check if old version is > 2.15 */
-/* ****************************** */
-// In preparation of next releases
-/*   $query = '
+/* Old version is > 2.15 */
+/* ********************* */
+	$query = '
 SELECT param
   FROM '.CONFIG_TABLE.'
-WHERE param LIKE "UserAdvManager%"
+WHERE param = "UserAdvManager_Redir"
 ;';
   $count = pwg_db_num_rows(pwg_query($query));
   
-  if ($count == 2)
-  {
-    upgrade_2151_2152();
-  }
-*/
+  if ($count == 0)
+  {
+    upgrade_2153_2154();
+  }
+
 load_conf_from_db('param like \'UserAdvManager\\_%\'');
 }
